import logging
from logging.handlers import RotatingFileHandler


class Logger():
    """ 
    A class to handle logging.
    Usage:
        from p2.logging import Logger

        log_obj = Logger(filename=<log filename>, level=<level>
        logger = log_obj.getLogger()
    """

    def __init__(self, filename: str='logfile', level=logging.DEBUG):
        logging.basicConfig(level=level)
        self.log = logging.getLogger(__name__)

        handler = RotatingFileHandler(
            filename+'.log',
            maxBytes=1000000,
            backupCount=5
            )

        # create formatter
        formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

        # add formatter to ch
        handler.setFormatter(formatter)
        self.log.addHandler(handler)


    def getLogger(self):
        return self.log
